// Suspend2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Suspend2.h"
#include "Suspend2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" __declspec(dllimport) void PowerOffSystem();

/////////////////////////////////////////////////////////////////////////////
// CSuspend2Dlg dialog

CSuspend2Dlg::CSuspend2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSuspend2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSuspend2Dlg)
	m_ResumeTimer = 0;
	m_SuspendTimer = 0;
	m_fPeriodic = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSuspend2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSuspend2Dlg)
	DDX_Text(pDX, IDC_EDIT_Resume, m_ResumeTimer);
	DDV_MinMaxDWord(pDX, m_ResumeTimer, 0, 3600);
	DDX_Text(pDX, IDC_EDIT_suspend, m_SuspendTimer);
	DDV_MinMaxDWord(pDX, m_SuspendTimer, 0, 3600);
	DDX_Check(pDX, IDC_CHECK_PERIODIC, m_fPeriodic);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSuspend2Dlg, CDialog)
	//{{AFX_MSG_MAP(CSuspend2Dlg)
	ON_EN_UPDATE(IDC_EDIT_suspend, OnUpdateEDITsuspend)
	ON_EN_UPDATE(IDC_EDIT_Resume, OnUpdateEDITResume)
	ON_BN_CLICKED(IDC_EXECUTE_SUSPEND, OnExecuteSuspend)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_StopTimers, OnStopTimers)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSuspend2Dlg message handlers

BOOL CSuspend2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CSuspend2Dlg::OnUpdateEDITsuspend() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
}

void CSuspend2Dlg::OnUpdateEDITResume() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
}

void CSuspend2Dlg::OnExecuteSuspend() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	m_nTimer = SetTimer(1,m_SuspendTimer*1000,NULL);
}

void CSuspend2Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CSuspend2Dlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}


extern "C"
{
	BOOL KernelIoControl(DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned);
}

// The following three definition are taken out of the ntddk.h file
// Please refer to this file for a description
//
#define METHOD_BUFFERED                 0
#define FILE_ANY_ACCESS                 0
#define FILE_DEVICE_HAL					0x00000101

#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)

// Kernel IOCTLs based on FILE_DEVICE_HAL -- last ID used is 67
// Note that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers..
// Internal product teams are currently using values in the range of 1000-1100

#define  IOCTL_RTC_ALARM_CALL          CTL_CODE(FILE_DEVICE_HAL, 4006, METHOD_BUFFERED, FILE_ANY_ACCESS)

void CSuspend2Dlg::OnTimer(UINT nIDEvent) 
{
	DWORD dwWakeTime, dwReturned, dwWakeTimeAccepted;
	// TODO: Add your message handler code here and/or call default
	CDialog::OnTimer(nIDEvent);
	if (!m_fPeriodic)
		if (m_nTimer)
			KillTimer(m_nTimer);

	dwWakeTime = m_ResumeTimer;
	KernelIoControl( IOCTL_RTC_ALARM_CALL, 
                                  (LPVOID)&dwWakeTime, 
                                  sizeof(DWORD), 
                                  (LPVOID)&dwWakeTimeAccepted, 
                                  sizeof(DWORD), 
                                  &dwReturned);
	//Suspend
	::keybd_event(VK_OFF, 0, 0, 0); 
	::keybd_event(VK_OFF, 0, KEYEVENTF_KEYUP, 0);
}

void CSuspend2Dlg::OnStopTimers() 
{
	// TODO: Add your control notification handler code here
	if (m_nTimer)
			KillTimer(m_nTimer);
}
